#ifndef __CSTRING_H__
#define __CSTRING_H__ 

#include <stdio.h>
#include <stdlib.h> 
#include <ctype.h>
#include <string.h>


typedef struct 
{
  char*           text;
  int             num;
} t_data;


typedef struct t_node 
{
  t_data          data;
  struct t_node*  next;
} t_list;


/******************************************************************************
 * Erstellt eine neue, leere Liste und liefert diese zurck.
 *****************************************************************************/
t_list* list_mkEmpty(void);



/******************************************************************************
 * Hngt ein neues Listenelement an die Liste list an und liefert die Liste
 * zurck.
 *****************************************************************************/
t_list* list_append(t_list* list, int num, char* text);



/******************************************************************************
 * Fgt ein Element hinter das Element after in die Liste list ein. 
 *****************************************************************************/
t_list* list_insert(t_list* list, t_list* after, int num, char* text);


/******************************************************************************
 * Wenn das Element elem in der Liste list enthalten ist, liefert diese 
 * Funktion 1 zurck, sonst 0.
 *****************************************************************************/
int list_inList(t_list* list, t_list* elem);



/******************************************************************************
 * Prft, ob es ein Element mit dem Text text in list gibt. Gibt einen Zeiger 
 * auf das Element zurck, oder NULL. Existieren mehrere Elemente mit diesem 
 * Text, so wird das Element zurckgeliefert, das sich am weitesten vorne in 
 * der Liste befindet.
 *****************************************************************************/
t_list* list_findText(t_list* list, char* text);



/******************************************************************************
 * Tauscht die Reihenfolge der Elemente x und y in list und gibt den 
 * Listenzeiger zurck.
 *****************************************************************************/
t_list* list_exchange(t_list* list, t_list* x, t_list* y);



/******************************************************************************
 * Hngt an den Text in dem Listenelement element den Text extratext an.
 *****************************************************************************/
void list_extendElement(t_list* element, char* extratext);



/******************************************************************************
 * Diese Funktion fgt die Listen list1 und list2 zusammen und liefert einen 
 * Listenzeiger zurck.
 *****************************************************************************/
t_list* list_concat(t_list* list1, t_list* list2);



/******************************************************************************
 * Entfernt das Element element aus der Liste list und gibt dann den 
 * Listenzeiger zurck.
 *****************************************************************************/
t_list* list_remove(t_list* list, t_list* element);



/******************************************************************************
 * Lscht die gesamte Liste list. Benutzt die Funktion list_remove um das zu 
 * realisieren.
 *****************************************************************************/
void list_destroy(t_list* list);


#endif
