#include <stdio.h>

#include "mylist.h"

t_list *list, *eins;


/******************************************************************************
 * Zhlt die Anzahl der Elemente der Liste
 *****************************************************************************/
int countlist(t_list *list)
{
 int i=0;
 t_list * p=list;

 if (!list)
   return 0;

 do
   {
      p = p->next;
      ++i;
   }
 while (p != list); 

 return i;
}

/******************************************************************************
 * Zeigt ein Element am Bildschirm an
 *****************************************************************************/
void showel(t_list * p, int i)
{
 if (p)
  printf("Nr %02d, p: [%d], next: [%d], num: '%d', text: '%s'\n",
                 i,
                 (int) p,
                 (int) p->next,
                 p->data.num, 
                 p->data.text);
 else
   printf("NULL\n");
}


/******************************************************************************
 * Zeigt eine gesamte Liste am Bildschirm an
 *****************************************************************************/
void showlist(t_list * list)
{
 t_list * p = list;
 int i = 0;

 if (!list)
   printf("<leere Liste>\n");
 else
 do
   {
      p = p->next;
      showel(p, i);
      ++i;
   }
 while (p != list);
}


/******************************************************************************
 * 1. --- Teste list_mkEmpty ---
 *****************************************************************************/
int test_mkEmpty(void)
{
 int res=1;

 printf("\n[ERZEUGE LEERE LISTE]\n");
 list = list_mkEmpty();
 res = res && (list == (t_list *) 0 );       /* Listenzeiger muss Null sein */
 showlist(list);
 res = res && (countlist(list)==0);          /* Liste darf kein Element haben */
 eins = list_mkEmpty();
 res = res && (eins == (t_list *) 0 );       /* Listenzeiger muss Null sein */

 return res;
}


/******************************************************************************
 * 2. --- Teste list_append ---
 *****************************************************************************/
int test_append(void)
{
 int res=1;

 printf("\n[ELEMENTE AN LISTE ANFUEGEN]\n");
 printf("Null als String:\n");
 list = list_append(list, 1, NULL);          /* NULL als String */
 res = res && (countlist(list)==1);
 showlist(list);

 printf("nochmal leeren String:\n");
 list = list_append(list, 2, "");            /* leeren String */
 res = res && (countlist(list)==2);
 showlist(list);

 printf("normalen String:\n");
 list = list_append(list, 3, "Hallo");       /* normalen String */
 res = res && (countlist(list)==3);
 showlist(list);

 return res;
}


/******************************************************************************
 * 3. --- Teste list_insert ---
 *****************************************************************************/
int test_insert(void)
{
 int res=1;
 t_list * t = list_mkEmpty();

 printf("\n[ELEMENTE AN LISTE EINFUEGEN]\n");
 printf("hinter 1. Element:\n");
 list = list_insert(list, list->next, 4, "vier");
 res = res && (countlist(list)==4);
 showlist(list);

 printf("hinter letztem Element:\n");
 list = list_insert(list, list, 5, "ganz hinten drin");
 res = res && (countlist(list)==5);
 showlist(list);

 printf("in der Mitte:\n");
 list = list_insert(list, list->next->next, 6, "In der Mitte");
 res = res && (countlist(list)==6);
 showlist(list);

 printf("after = null:\n");
 list = list_insert(list, NULL, 7, "sieben");
 res = res && (countlist(list)==6);
 showlist(list);

 printf("list=null:\n");
 t = list_insert(NULL, list->next, 1, "t 1");
 res = res && (countlist(t)==0);
 showlist(t);

 printf("after=list=null:\n");
 t = list_insert(NULL, NULL, 2, "t 2");
 res = res && (countlist(t)==0);
 showlist(t);

 return res;
}


/******************************************************************************
 * 4. --- Teste list_inList ---
 *****************************************************************************/
int test_inList(void)
{
 int res=1;
 int i=23;
 t_list * t;

 printf("\n[IN DER LISTE SUCHEN]\n");
 i = list_inList(list, NULL);
 printf("nach Null suchen: %d\n", i);
 res = res && i==0;

 i = list_inList(list, list);
 printf("nach list suchen: %d\n", i);
 res = res && i==1;

 i = list_inList(list, list->next);
 printf("nach list->next suchen: %d\n", i);
 res = res && i==1;

 i = list_inList(list, list->next->next);
 printf("nach list->next->next suchen: %d\n", i);
 res = res && i==1;

 t = list_mkEmpty();
 i = list_inList(t, t);
 printf("nach t=0 suchen: %d\n", i);
 res = res && i==0;

 i = list_inList(t, list);
 printf("in t nach list suchen: %d\n", i);
 res = res && i==0;

 eins = list_append(eins,1,"list-eins");
 i = list_inList(eins, list);
 printf("in eins nach list suchen: %d\n", i);
 res = res && i==0;

 i = list_inList(eins, NULL);
 printf("in eins nach NULL suchen: %d\n", i);
 res = res && i==0;

 i = list_inList(eins, eins);
 printf("in eins nach eins suchen: %d\n", i);
 res = res && i==1;

 return res;
}

/******************************************************************************
 * 5. --- Teste list_findText ---
 *****************************************************************************/
int test_findText(void)
{
 int res=1;
 t_list * t;

 printf("\n[NACH TEXT SUCHEN]\n");

 printf("leeren Text:\n");
 t = list_findText(list, "");
 showlist(list);
 printf("Gefunden:\n");
 showel(t,1);
 res = res && (t!=NULL);

 printf("\nNull Text:\n");
 t = list_findText(list, NULL);
 showlist(list);
 printf("Gefunden:\n");
 showel(t,1);
 res = res && (t==NULL);

 list = list_remove(list,list->next);

 printf("\nlist Ende Text:\n");
 t = list_findText(list, list->data.text);
 showlist(list);
 printf("Gefunden:\n");
 showel(t,1);
 res = res && (t!=NULL);

 printf("\nlist Mitte Text:\n");
 t = list_findText(list, list->next->next->data.text);
 showlist(list);
 printf("Gefunden:\n");
 showel(t,1);
 res = res && (t!=NULL);

 printf("\nlist Anfang Text:\n");
 t = list_findText(list, list->next->data.text);
 showlist(list);
 printf("Gefunden:\n");
 showel(t,1);
 res = res && (t!=NULL);

 printf("\neins list und eins:\n");
 t = list_findText(eins, eins->data.text);
 showlist(eins);
 printf("Gefunden:\n");
 showel(t,1);
 res = res && (t!=NULL);

 printf("\neins list und list:\n");
 t = list_findText(eins, "test");
 showlist(eins);
 printf("Gefunden:\n");
 showel(t,1);
 res = res && (t==NULL);

 return res;
}

/******************************************************************************
 * 6. --- Teste list_exchange ---
 *****************************************************************************/
int test_exchange(void)
{
 int res=1;
 t_list * t = list_mkEmpty();

 printf("\n[ELEMENTE TAUSCHEN]\n");

 printf("\nerstes und letztes tauschen:\n");
 showlist(list);
 list = list_exchange(list, list->next, list);
 printf("NeueListe:\n");
 showlist(list);
 res = res && (countlist(list)==5);

 printf("\nletztes und erstes tauschen:\n");
 showlist(list);
 list = list_exchange(list, list, list->next);
 printf("NeueListe:\n");
 showlist(list);
 res = res && (countlist(list)==5);

 printf("\nzwei mittendrin:\n");
 showlist(list);
 list = list_exchange(list, list->next->next, list->next->next->next);
 printf("NeueListe:\n");
 showlist(list);
 res = res && (countlist(list)==5);

 printf("\nbeide el gleich:\n");
 showlist(list);
 list = list_exchange(list, list->next, list->next);
 printf("NeueListe:\n");
 showlist(list);
 res = res && (countlist(list)==5);

 printf("\nersets el unguelitg:\n");
 showlist(list);
 list = list_exchange(list, t, list->next);
 printf("NeueListe:\n");
 showlist(list);
 res = res && (countlist(list)==5);

 printf("\nzweites el unguelitg:\n");
 showlist(list);
 list = list_exchange(list, list, eins);
 printf("NeueListe:\n");
 showlist(list);
 res = res && (countlist(list)==5);

 printf("\nzu kleine liste:\n");
 showlist(eins);
 eins = list_exchange(eins, list, eins);
 printf("NeueListe:\n");
 showlist(eins);
 res = res && (countlist(eins)==1);

 printf("\nNULL als Liste:\n");
 res = res && !list_exchange(NULL, list, eins);

 return res;
}


/******************************************************************************
 * 7. --- Teste list_extendElement ---
 *****************************************************************************/
int test_extendElement(void)
{
 int res=1;


 printf("\n[TEXT ERWEITERN]\n");

 printf("\nnormaler Text:\n");
 showel(list,1);
 list_extendElement(list, "mehr");
 printf("Neues Element:\n");
 showel(list,1);

 printf("\nnochmal text:\n");
 showel(list->next->next,1);
 list_extendElement(list, " andi");
 printf("Neues Element:\n");
 showel(list->next->next,1);

 printf("\nNULL Text:\n");
 showel(list,1);
 list_extendElement(list, NULL);
 printf("Neues Element:\n");
 showel(list,1);

 printf("\nNULL Element:\n");
 list_extendElement(NULL, "mehr");
 printf("Neues Element:\n");

 printf("\nleerer Text:\n");
 showel(list,1);
 list_extendElement(list, "");
 printf("Neues Element:\n");
 showel(list,1);

 list_destroy(eins);
 eins = list_mkEmpty();
 eins = list_append(eins,1,"");
 printf("\nleeres Element:\n");
 showel(eins,1);
 list_extendElement(eins, "juhu");
 printf("Neues Element:\n");
 showel(eins,1);

 return res;
}

/******************************************************************************
 * 8. --- Teste list_concat ---
 *****************************************************************************/
int test_concat(void)
{
 int res=1;
 t_list * t;

 printf("\n[LISTEN CONCATEN]\n");

 printf("\nList list:\n");
 showlist(list);
 printf("\nList eins:\n");
 showlist(eins);
 t = list_concat(list, eins);
 printf("Neue Liste:\n");
 showlist(t);

 printf("\nt list mit sich selbst:\n");
 showlist(t);
 t = list_concat(t, t);
 printf("Neue Liste:\n");
 showlist(t);

 printf("\nt list + leere Liste:\n");
 showlist(t);
 t = list_concat(t, list_mkEmpty());
 printf("Neue Liste:\n");
 showlist(t);

 printf("\nleere Liste + t list\n");
 showlist(t);
 t = list_concat(list_mkEmpty(), t);
 printf("Neue Liste:\n");
 showlist(t);
 list = t;

 return res;
}

/******************************************************************************
 * 9. --- Teste list_remove ---
 *****************************************************************************/
int test_remove(void)
{
 int res=1;
 printf("\n[ELEMENT ENTFERNEN]\n");

 printf("\naus der mitte entfernen:\n");
 showlist(list);
 list = list_remove(list, list->next->next);
 printf("Neue Liste:\n");
 showlist(list);
 res = res && (countlist(list)==5);

 printf("\nletzte element entfernen:\n");
 showlist(list);
 list = list_remove(list, list);
 printf("Neue Liste:\n");
 showlist(list);
 res = res && (countlist(list)==4);

 printf("\nletzte element entfernen:\n");
 showlist(list);
 list = list_remove(list, list);
 printf("Neue Liste:\n");
 showlist(list);
 res = res && (countlist(list)==3);

 printf("\nerstes element entfernen:\n");
 showlist(list);
 list = list_remove(list, list->next);
 printf("Neue Liste:\n");
 showlist(list);
 res = res && (countlist(list)==2);

 printf("\nerstes element entfernen:\n");
 showlist(list);
 list = list_remove(list, list->next);
 printf("Neue Liste:\n");
 showlist(list);
 res = res && (countlist(list)==1);

 printf("\nleeres element entfernen:\n");
 showlist(list);
 list = list_remove(list, list_mkEmpty());
 printf("Neue Liste:\n");
 showlist(list);
 res = res && (countlist(list)==1);

 printf("\nerstes element entfernen:\n");
 showlist(list);
 list = list_remove(list, list->next);
 printf("Neue Liste:\n");
 showlist(list);
 res = res && (countlist(list)==0);

 printf("\nleere liste entfernen:\n");
 showlist(list);
 list = list_remove(list, eins);
 printf("Neue Liste:\n");
 showlist(list);
 res = res && (countlist(list)==0);

 return res;
}

/******************************************************************************
 * 10. --- Teste list_destroy ---
 *****************************************************************************/
int test_destroy(void)
{
 int res=1;

 printf("\n[LISTEN FREIGEBEN]\n");

 printf("\nein Element freigeben:\n");
 list = list_append(list, 12, "neu");
 list_destroy(list);

 printf("\nmehrere Elemente freigeben:\n");
 list = list_append(list, 12, "neu");
 list = list_append(list, 12, "neu");
 list = list_append(list, 12, "neu");
 list_destroy(list);
 
 return res;
}




int main (int argc, char * argv[])
{
 
 if (test_mkEmpty() )         printf("---> Test 1. OK!\n");
 else                         printf("---> Test FEHLER!\n"), exit(1);

 if (test_append() )          printf("---> Test 2. OK!\n");
 else                         printf("---> Test FEHLER!\n"), exit(1);

 if (test_insert() )          printf("---> Test 3. OK!\n");
 else                         printf("---> Test FEHLER!\n"), exit(1);

 if (test_inList() )          printf("---> Test 4. OK!\n");
 else                         printf("---> Test FEHLER!\n"), exit(1);

 if (test_findText() )        printf("---> Test 5. OK!\n");
 else                         printf("---> Test FEHLER!\n"), exit(1);

 if (test_exchange() )        printf("---> Test 6. OK!\n");
 else                         printf("---> Test FEHLER!\n"), exit(1);

 if (test_extendElement() )   printf("---> Test 7 OK!\n");
 else                         printf("---> Test FEHLER!\n"), exit(1);

 if (test_concat() )          printf("---> Test 8. OK!\n");
 else                         printf("---> Test FEHLER!\n"), exit(1);

 if (test_remove() )          printf("---> Test 9. OK!\n");
 else                         printf("---> Test FEHLER!\n"), exit(1);

 if (test_destroy() )         printf("---> Test 10. OK!\n");
 else                         printf("---> Test FEHLER!\n"), exit(1);

 printf("\n\n--> TEST ERFOLGREICH!\n\n");

 return 0;
}

